local DCL,d=... -- DO NOT REMOVE THIS LINE

local Decliner=CreateFrame('frame',DCL)
local DeclinerPanel=CreateFrame('frame',DCL..'Panel')
local DeclinerUpdate=CreateFrame('frame',DCL..'Update')

Decliner_SV={}
d.v={
	saved=false,
	default={
		duel={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
		pet={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
		guild={enabled=true,tell=false,friend=false,bnet=false,message=false,},
		group={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
		chart={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
		trade={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
		dcl={messages=false,disable=false,},
	},
	opt={
		duel={enabled,tell,guild,friend,bnet,message,},
		pet={enabled,tell,guild,friend,bnet,message,},
		guild={enabled,tell,friend,bnet,message,},
		group={enabled,tell,guild,friend,bnet,message,},
		chart={enabled,tell,guild,friend,bnet,message,},
		trade={enabled,tell,guild,friend,bnet,message,},
		dcl={messages,disable,},
	},
	temp={},
}

local _StaticPopupDialogs,Ambiguate,checkboxnum,DeclinerDialog,format,gsub,mcount,pairs,random,strlower,strmatch,strupper,textnum,type,update=
{},Ambiguate,0,{},format,gsub,{},pairs,random,strlower,strmatch,strupper,0,type,0

local _,access,action,addon,alert,alpha,chatframe,chckbx,checkbox,checkboxname,client,cti,data,dialog,duelerrormsg,duelreqmsg,frame,groupinvmsg,guild,guildinvmsg,justify,lastwhisper,line,message,msg,name,namerealm,notfound,oldSFX,OnHide,online,OnShow,originator,pattern,petduelmsg,peterrormsg,ptype,realm,realm,settext,soundhandle,spam,switch,text,textname,tooltip,tradeerrormsg,tradeinimsg,tradeinitiated,var,which,x,xloc,yloc

function Decliner:Pattern(pattern)
	pattern=gsub(pattern,'|Hpatternlayer:','')
	pattern=gsub(pattern,'%%%d?$?c','')
	pattern=gsub(pattern,'%%%d?$?d','')
	pattern=gsub(pattern,'%%%d?$?s','')
	pattern=gsub(pattern,'%[.*%]','')
	pattern=gsub(pattern,':.*','')
	pattern=gsub(pattern,'|h','')
	pattern=gsub(pattern,'%.','')
	pattern=gsub(pattern,'^%s','')
	pattern=gsub(pattern,'%s$','')
	return pattern
end

duelerrormsg='.*'..Decliner:Pattern(ERR_DUEL_CANCELLED)..'.*'
peterrormsg='.*'..Decliner:Pattern(ERR_PETBATTLE_DECLINED)..'.*'
tradeerrormsg='.*'..Decliner:Pattern(ERR_TRADE_CANCELLED)..'.*'
tradeinimsg='.*'..Decliner:Pattern(ERR_INITIATE_TRADE_S)..'.*'
duelreqmsg='.*'..Decliner:Pattern(DUEL_REQUESTED)..'.*'
petduelmsg='.*'..Decliner:Pattern(PET_BATTLE_PVP_DUEL_REQUESTED)..'.*'
guildinvmsg='.*'..Decliner:Pattern(ERR_INVITED_TO_GUILD_SSS)..'.*'
groupinvmsg='.*'..Decliner:Pattern(ERR_INVITED_TO_GROUP_SS)..'.*'

function Decliner:IsAllowed(namerealm,var)
	if not d.v.opt[var].enabled then return true end
	if not d.v.opt[var].tell and namerealm == lastwhisper then return true end
	if var ~= 'guild' then
		if not d.v.opt[var].guild and IsInGuild() then
			for i=1,(GetNumGuildMembers()) do
				if namerealm == Ambiguate((GetGuildRosterInfo(i)),'mail') then return true end
			end
		end
	end
	if not d.v.opt[var].friend then
		for i=1,(GetNumFriends()) do
			if namerealm == Ambiguate((GetFriendInfo(i)),'mail') then return true end
		end
	end
	if not d.v.opt[var].bnet then
		for i=1,(BNGetNumFriends()) do
			_,_,_,_,_,_,client,online=BNGetFriendInfo(i)
			if client == 'WoW' and online then
				for j=1,(BNGetNumFriendToons(i)) do
					_,name,_,realm=BNGetFriendToonInfo(i,j)
					if namerealm == name..'-'..realm then return true end
				end
			end
		end
	end
	return false
end

function Decliner:Print(message)
	if d.v.opt.dcl.messages then return end
	if spam ~= nil then if message == spam then return end end spam=message
	cti,notfound=ChatTypeInfo['SYSTEM'],true
	for i=1,NUM_CHAT_WINDOWS do
		chatframe=_G['ChatFrame'..i]
		if chatframe:IsEventRegistered('CHAT_MSG_SYSTEM') then notfound=false
			chatframe:AddMessage('|cffff0000'..DCL..': |r'..message..'',cti.r,cti.g,cti.b,cti.id)
		end
	end
	if notfound then
		DEFAULT_CHAT_FRAME:AddMessage('|cffff0000'..DCL..': |r'..message..'',cti.r,cti.g,cti.b,cti.id)
	end
end

function Decliner:ADDON_LOADED(addon)
	if addon ~= DCL then return end
	_StaticPopupDialogs['DUEL_REQUESTED']=StaticPopupDialogs['DUEL_REQUESTED']
	_StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']
	_StaticPopupDialogs['PARTY_INVITE']=StaticPopupDialogs['PARTY_INVITE']
	_StaticPopupDialogs['PARTY_INVITE_XREALM']=StaticPopupDialogs['PARTY_INVITE_XREALM']
	if Decliner_SV.saved then
		for key1,value1 in pairs(d.v.default) do
			if Decliner_SV[key1] == nil then
				Decliner_SV[key1]=d.v.default[key1]
			end
			for key2,value2 in pairs(value1) do
				if Decliner_SV[key1][key2] == nil then
					Decliner_SV[key1][key2]=d.v.default[key1][key2]
				elseif type(Decliner_SV[key1][key2]) ~= 'boolean' then
					Decliner_SV[key1][key2]=d.v.default[key1][key2]
				end
			end
		end
		d.v.opt=Decliner_SV
		Decliner_SV.saved=true
	else
		d.v.opt=d.v.default
		Decliner_SV=d.v.default
		Decliner_SV.saved=true
	end
	DeclinerPanel:Options()
	DeclinerPanel:MainEventReg()
	oldSFX=GetCVar('Sound_EnableSFX')
	Decliner:Print(''..strlower(GAME_VERSION_LABEL)..' '..GetAddOnMetadata(DCL,'Version')..' '..strlower(READY)..'')
	Decliner:UnregisterEvent('ADDON_LOADED')
end

function Decliner:CHAT_MSG_SYSTEM(message)
	if strmatch(message,tradeinimsg) then tradeinitiated=true end
end

function Decliner:CHAT_MSG_WHISPER_INFORM(_,name)
	lastwhisper=Ambiguate(name,'mail')
end

function Decliner:CVAR_UPDATE(cvar,value)
	oldSFX=GetCVar('Sound_EnableSFX')
	if cvar == 'BLOCK_TRADES' and value == '0' and not d.v.opt.trade.enabled then
		d.v.opt.trade.enabled=true
		Decliner:Print(d.L['BLOCK_TRADES_OFF'])
	elseif cvar == 'BLOCK_TRADES' and value == '1' and d.v.opt.trade.enabled then
		d.v.opt.trade.enabled=false
		Decliner:Print(d.L['BLOCK_TRADES_ON'])
	end
end

function Decliner:DISABLE_DECLINE_GUILD_INVITE()
	if d.v.opt.guild.enabled then return end
	d.v.opt.guild.enabled=true
	Decliner:Print(d.L['BLOCK_GUILDS_OFF'])
end

function Decliner:ENABLE_DECLINE_GUILD_INVITE()
	if not d.v.opt.guild.enabled then return end
	d.v.opt.guild.enabled=false
	Decliner:Print(d.L['BLOCK_GUILDS_ON'])
end

function Decliner:DUEL_REQUESTED(name)
	_,frame=StaticPopup_Visible('DUEL_REQUESTED')
	HideUIPanel(frame)
	namerealm=Ambiguate(name,'mail')
	if Decliner:IsAllowed(namerealm,'duel') then
		Decliner:SetStaticPopup(frame,'default')
		ShowUIPanel(frame)
		PlaySoundKitID(880)
	else
		CancelDuel()
		name=Ambiguate(name,'none')
		if not d.v.opt.duel.message then
			Decliner:Print(format(d.L['DUEL_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h'))
		end
	end
end

function Decliner:PET_BATTLE_PVP_DUEL_REQUESTED(name)
	_,frame=StaticPopup_Visible('PET_BATTLE_PVP_DUEL_REQUESTED')
	HideUIPanel(frame)
	namerealm=Ambiguate(name,'mail')
	if Decliner:IsAllowed(namerealm,'pet') then
		Decliner:SetStaticPopup(frame,'default')
		ShowUIPanel(frame)
		PlaySoundKitID(880)
	else
		C_PetBattles.CancelPVPDuel()
		name=Ambiguate(name,'none')
		if not d.v.opt.pet.message then
			Decliner:Print(format(d.L['PET_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h'))
		end
	end
end

function Decliner:GUILD_INVITE_REQUEST(name,guild)
	SetCVar('Sound_EnableSFX','0')
	namerealm=Ambiguate(name,'mail')
	if Decliner:IsAllowed(namerealm,'guild') then
		C_Timer.After(0.5,function()
			SetCVar('Sound_EnableSFX',oldSFX)
			PlaySoundKidID(888)
		end)
	else
		StaticPopupSpecial_Hide(GuildInviteFrame)
		DeclineGuild()
		name=Ambiguate(name,'none')
		if not d.v.opt.guild.message then
			Decliner:Print(format(d.L['GUILD_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h',guild))
		end
		C_Timer.After(0.5,function() SetCVar('Sound_EnableSFX',oldSFX) end)
	end
end

function Decliner:PARTY_INVITE_REQUEST(name)
	_,frame=StaticPopup_Visible('PARTY_INVITE') which='PARTY_INVITE'
	if not frame then
		_,frame=StaticPopup_Visible('PARTY_INVITE_XREALM') which='PARTY_INVITE_XREALM'
	end
	HideUIPanel(frame)
	namerealm=Ambiguate(name,'mail')
	if Decliner:IsAllowed(namerealm,'group') then
		Decliner:SetStaticPopup(frame,'default')
		ShowUIPanel(frame)
		PlaySoundKitID(880)
		StaticPopupDialogs[which].OnHide=function(self)
			if not self.inviteAccepted then
				DeclineGroup()
				self:Hide()
			end
			StaticPopupDialogs[which]=DeclinerDialog[which]
		end
	else
		DeclineGroup()
		name=Ambiguate(name,'none')
		if not d.v.opt.group.message then
			Decliner:Print(format(d.L['GROUP_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h'))
		end
	end
end

function Decliner:PETITION_SHOW()
	HideUIPanel(PetitionFrame)
	ptype,_,_,_,name,originator=GetPetitionInfo()
	namerealm=Ambiguate(name,'mail')
	if originator or Decliner:IsAllowed(namerealm,'chart') then
		Decliner:SetPetitionFrame('default')
		ShowUIPanel(PetitionFrame)
	else
		ClosePetition()
		name=Ambiguate(name,'none')
		if not d.v.opt.chart.message then
			if ptype == 'arena' then
				Decliner:Print(format(d.L['CHART_DECLINED_ARENA'],'|Hplayer:'..name..'|h['..name..']|h'))
			elseif ptype == 'guild' then
				Decliner:Print(format(d.L['CHART_DECLINED_GUILD'],'|Hplayer:'..name..'|h['..name..']|h'))
			else Decliner:Print(format(d.L['CHART_DECLINED_NIL'],'|Hplayer:'..name..'|h['..name..']|h'))
			end
		end
	end
end

function Decliner:TRADE_SHOW()
	HideUIPanel(TradeFrame)
	name,realm=UnitName('npc')
	if not realm then
		namerealm=Ambiguate(name,'mail')
	else
		namerealm=name..'-'..realm
	end
	if tradeinitiated or Decliner:IsAllowed(namerealm,'chart') then
		Decliner:SetTradeFrame('default')
		ShowUIPanel(TradeFrame)
	else
		CloseTrade()
		name=Ambiguate(name,'none')
		if not d.v.opt.trade.message then
			Decliner:Print(format(d.L['TRADE_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h'))
		end
	end
end

function Decliner:TRADE_CLOSED()
	tradeinitiated=false
end

function Decliner:UI_INFO_MESSAGE(message)
	if d.v.opt.dcl.disable then return end
	if strmatch(message,duelerrormsg) and not Decliner:IsAllowed(namerealm,'duel') then UIErrorsFrame:Clear() end
	if strmatch(message,peterrormsg) and not Decliner:IsAllowed(namerealm,'pet') then UIErrorsFrame:Clear() end
	if strmatch(message,tradeerrormsg) and not Decliner:IsAllowed(namerealm,'trade') then UIErrorsFrame:Clear() end
end

Decliner:RegisterEvent('ADDON_LOADED')
Decliner:RegisterEvent('CHAT_MSG_SYSTEM')
Decliner:RegisterEvent('CHAT_MSG_WHISPER_INFORM')
Decliner:RegisterEvent('CVAR_UPDATE')
Decliner:RegisterEvent('DISABLE_DECLINE_GUILD_INVITE')
Decliner:RegisterEvent('ENABLE_DECLINE_GUILD_INVITE')
Decliner:SetScript('OnEvent',function(self,event,...) self[event](self,...) end)

ChatFrame_AddMessageEventFilter('CHAT_MSG_SYSTEM',function(_,_,message)
	if d.v.opt.dcl.disable then return false end
	if strmatch(message,duelreqmsg) and not Decliner:IsAllowed(namerealm,'duel') then return true end
	if strmatch(message,petduelmsg) and not Decliner:IsAllowed(namerealm,'pet') then return true end
	if strmatch(message,guildinvmsg) and not Decliner:IsAllowed(namerealm,'guild') then return true end
	if strmatch(message,groupinvmsg) and not Decliner:IsAllowed(namerealm,'group') then return true end
	return false
end)

DeclinerDialog['DUEL_REQUESTED']={
	text=DUEL_REQUESTED,
	button1=ACCEPT,
	button2=DECLINE,
	OnAccept=function(self)
		AcceptDuel()
	end,
	OnCancel=function(self)
		CancelDuel()
	end,
	timeout=STATICPOPUP_TIMEOUT,
	hideOnEscape=1
}

DeclinerDialog['PET_BATTLE_PVP_DUEL_REQUESTED']={
	text=PET_BATTLE_PVP_DUEL_REQUESTED,
	button1=ACCEPT,
	button2=DECLINE,
	OnAccept=function(self)
		C_PetBattles.AcceptPVPDuel()
	end,
	OnCancel=function(self)
		C_PetBattles.CancelPVPDuel()
	end,
	timeout=STATICPOPUP_TIMEOUT,
	hideOnEscape=1
}

DeclinerDialog['PARTY_INVITE']={
	text=INVITATION,
	button1=ACCEPT,
	button2=DECLINE,
	OnShow=function(self)
		self.inviteAccepted=nil
	end,
	OnAccept=function(self)
		AcceptGroup()
		self.inviteAccepted=1
	end,
	OnCancel=function(self)
		DeclineGroup()
	end,
	OnHide=function(self)
		if (not self.inviteAccepted) then
			self:Hide()
		end
	end,
	timeout=STATICPOPUP_TIMEOUT,
	whileDead=1,
	hideOnEscape=1
}

DeclinerDialog['PARTY_INVITE_XREALM']={
	text=INVITATION_XREALM,
	button1=ACCEPT,
	button2=DECLINE,
	OnShow=function(self)
		self.inviteAccepted=nil
	end,
	OnAccept=function(self)
		AcceptGroup()
		self.inviteAccepted=1
	end,
	OnCancel=function(self)
		DeclineGroup()
	end,
	OnHide=function(self)
		if (not self.inviteAccepted) then
			self:Hide()
		end
	end,
	timeout=STATICPOPUP_TIMEOUT,
	whileDead=1,
	hideOnEscape=1
}

local DeclinerDialog_OnShow=function(frame)
	dialog=frame.which
	if dialog and
	((dialog == 'DUEL_REQUESTED' and d.v.opt.duel.enabled) or
	(dialog == 'PET_BATTLE_PVP_DUEL_REQUESTED' and d.v.opt.pet.enabled) or
	((dialog == 'PARTY_INVITE' or dialog == 'PARTY_INVITE_XREALM') and d.v.opt.group.enabled)) then
		OnShow=dialog.OnShow
		if (OnShow) then
			OnShow(frame,frame.data)
		end
		if (dialog.enterClicksFirstButton) then
			frame:SetScript('OnKeyDown',StaticPopup_OnKeyDown)
		end
	else
		StaticPopup_OnShow(frame)
	end
end

local DeclinerDialog_OnHide=function(frame)
	dialog=frame.which
	if dialog and
	((dialog == 'DUEL_REQUESTED' and d.v.opt.duel.enabled) or
	(dialog == 'PET_BATTLE_PVP_DUEL_REQUESTED' and d.v.opt.pet.enabled) or
	((dialog == 'PARTY_INVITE' or dialog == 'PARTY_INVITE_XREALM') and d.v.opt.group.enabled)) then
		StaticPopup_CollapseTable()
		OnHide=dialog.OnHide
		if (OnHide) then
			OnHide(frame,frame.data)
		end
		if (dialog.enterClicksFirstButton) then
			frame:SetScript('OnKeyDown',nil)
		end
	else
		StaticPopup_OnHide(frame)
	end
end

function Decliner:SetStaticPopup(frame,action)
	frame:SetScript('OnShow',nil)
	frame:SetScript('OnHide',nil)
	if action == 'decline' then
		frame:SetScript('OnShow',function()
			DeclinerDialog_OnShow(frame)
		end)
		frame:SetScript('OnHide',function()
			DeclinerDialog_OnHide(frame)
		end)
	elseif action == 'default' and d.v.opt.dcl.disable then
		frame:SetScript('OnShow',function()
			StaticPopup_OnShow(frame)
		end)
		frame:SetScript('OnHide',function()
			StaticPopup_OnHide(frame)
		end)
	elseif action == 'default' then
		frame:SetScript('OnShow',function()
			StaticPopup_OnShow(frame)
		end)
		frame:SetScript('OnHide',function()
			StaticPopup_OnHide(frame)
			if d.v.opt.duel.enabled or d.v.opt.pet.enabled or d.v.opt.group.enabled then
				Decliner:SetStaticPopup(frame,'decline')
			end
		end)
	end
end

function Decliner:SetPetitionFrame(action)
	PetitionFrame:SetScript('OnShow',nil)
	PetitionFrame:SetScript('OnHide',nil)
	if action == 'decline' then
		PetitionFrame:SetScript('OnHide',function()
			StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
		end)
	elseif action == 'default' and d.v.opt.dcl.disable then
		PetitionFrame:SetScript('OnShow',function()
			PlaySoundKitID(875)
		end)
		PetitionFrame:SetScript('OnHide',function()
			PlaySoundKitID(876)
			StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
			ClosePetition()
		end)
	elseif action == 'default' then
		PetitionFrame:SetScript('OnShow',function()
			PlaySoundKitID(875)
		end)
		PetitionFrame:SetScript('OnHide',function()
			PlaySoundKitID(876)
			StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
			ClosePetition()
			if d.v.opt.chart.enabled then Decliner:SetPetitionFrame('decline') end
		end)
	end
end

function Decliner:SetTradeFrame(action)
	TradeFrame:SetScript('OnShow',nil)
	TradeFrame:SetScript('OnHide',nil)
	if action == 'decline' then
		TradeFrame:SetScript('OnShow',function()
			TradeFrame_OnShow(self)
		end)
		TradeFrame:SetScript('OnHide',function()
			MoneyInputFrame_SetCopper(TradePlayerInputMoneyFrame,0)
		end)
	elseif action == 'default' and d.v.opt.dcl.disable then
		TradeFrame:SetScript('OnShow',function()
			TradeFrame_OnShow(self)
			PlaySoundKitID(839)
		end)
		TradeFrame:SetScript('OnHide',function()
			TradeFrame_OnHide()
			PlaySoundKitID(840)
		end)
	elseif action == 'default' then
		TradeFrame:SetScript('OnShow',function()
			TradeFrame_OnShow(self)
			PlaySoundKitID(839)
		end)
		TradeFrame:SetScript('OnHide',function()
			TradeFrame_OnHide()
			PlaySoundKitID(840)
			if d.v.opt.trade.enabled then Decliner:SetTradeFrame('decline') end
		end)
	end
end

function DeclinerPanel:MainEventReg()
	if d.v.opt.dcl.disable then
		Decliner:UnregisterAllEvents()
		StaticPopupDialogs['DUEL_REQUESTED']=_StaticPopupDialogs['DUEL_REQUESTED']
		StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=_StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']
		StaticPopupDialogs['PARTY_INVITE']=_StaticPopupDialogs['PARTY_INVITE']
		StaticPopupDialogs['PARTY_INVITE_XREALM']=_StaticPopupDialogs['PARTY_INVITE_XREALM']
		Decliner:SetPetitionFrame('default')
		Decliner:SetTradeFrame('default')
		for i=1,STATICPOPUP_NUMDIALOGS do
			frame=_G['StaticPopup'..i]
			Decliner:SetStaticPopup(frame,'default')
		end
	else
		if not Decliner:IsEventRegistered('CHAT_MSG_SYSTEM') then Decliner:RegisterEvent('CHAT_MSG_SYSTEM') end
		if not Decliner:IsEventRegistered('CHAT_MSG_WHISPER_INFORM') then Decliner:RegisterEvent('CHAT_MSG_WHISPER_INFORM') end
		if not Decliner:IsEventRegistered('CVAR_UPDATE') then Decliner:RegisterEvent('CVAR_UPDATE') end
		if not Decliner:IsEventRegistered('DISABLE_DECLINE_GUILD_INVITE') then Decliner:RegisterEvent('DISABLE_DECLINE_GUILD_INVITE') end
		if not Decliner:IsEventRegistered('ENABLE_DECLINE_GUILD_INVITE') then Decliner:RegisterEvent('ENABLE_DECLINE_GUILD_INVITE') end
		if d.v.opt.duel.enabled then
			Decliner:RegisterEvent('DUEL_REQUESTED')
			StaticPopupDialogs['DUEL_REQUESTED']=DeclinerDialog['DUEL_REQUESTED']
		else
			Decliner:UnregisterEvent('DUEL_REQUESTED')
			StaticPopupDialogs['DUEL_REQUESTED']=_StaticPopupDialogs['DUEL_REQUESTED']
		end
		if d.v.opt.pet.enabled then
			Decliner:RegisterEvent('PET_BATTLE_PVP_DUEL_REQUESTED')
			StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=DeclinerDialog['PET_BATTLE_PVP_DUEL_REQUESTED']
		else
			Decliner:UnregisterEvent('PET_BATTLE_PVP_DUEL_REQUESTED')
			StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=_StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']
		end
		if d.v.opt.guild.enabled then
			Decliner:RegisterEvent('GUILD_INVITE_REQUEST')
		else
			Decliner:UnregisterEvent('GUILD_INVITE_REQUEST')
		end
		if d.v.opt.group.enabled then
			Decliner:RegisterEvent('PARTY_INVITE_REQUEST')
			StaticPopupDialogs['PARTY_INVITE']=DeclinerDialog['PARTY_INVITE']
			StaticPopupDialogs['PARTY_INVITE_XREALM']=DeclinerDialog['PARTY_INVITE_XREALM']
		else
			Decliner:UnregisterEvent('PARTY_INVITE_REQUEST')
			StaticPopupDialogs['PARTY_INVITE']=_StaticPopupDialogs['PARTY_INVITE']
			StaticPopupDialogs['PARTY_INVITE_XREALM']=_StaticPopupDialogs['PARTY_INVITE_XREALM']
		end
		if d.v.opt.chart.enabled then
			Decliner:RegisterEvent('PETITION_SHOW')
			Decliner:SetPetitionFrame('decline')
		else
			Decliner:UnregisterEvent('PETITION_SHOW')
			Decliner:SetPetitionFrame('default')
		end
		if d.v.opt.trade.enabled then
			Decliner:RegisterEvent('TRADE_SHOW')
			Decliner:RegisterEvent('TRADE_CLOSED')
			Decliner:SetTradeFrame('decline')
		else
			Decliner:UnregisterEvent('TRADE_SHOW')
			Decliner:UnregisterEvent('TRADE_CLOSED')
			Decliner:SetTradeFrame('default')
		end
		if d.v.opt.duel.enabled or d.v.opt.pet.enabled or d.v.opt.group.enabled then
			for i=1,STATICPOPUP_NUMDIALOGS do
				frame=_G['StaticPopup'..i]
				Decliner:SetStaticPopup(frame,'decline')
			end
		else
			for i=1,STATICPOPUP_NUMDIALOGS do
				frame=_G['StaticPopup'..i]
				Decliner:SetStaticPopup(frame,'default')
			end
		end
		if d.v.opt.duel.enabled or d.v.opt.pet.enabled or d.v.opt.trade.enabled then Decliner:RegisterEvent('UI_INFO_MESSAGE') else Decliner:UnregisterEvent('UI_INFO_MESSAGE') end
	end
end

function Decliner:BlizzardGT()
	if d.v.opt.guild.enabled and not d.v.opt.dcl.disable then
		_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText('|cff666666'..BLOCK_GUILD_INVITES..' (Decliner)')
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:Disable()
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:SetChecked(false)
	else
		_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText(BLOCK_GUILD_INVITES)
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:Enable()
	end
	if d.v.opt.trade.enabled and not d.v.opt.dcl.disable then
		_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText('|cff666666'..BLOCK_TRADES..' (Decliner)')
		_G['InterfaceOptionsControlsPanelBlockTrades']:Disable()
		_G['InterfaceOptionsControlsPanelBlockTrades']:SetChecked(false)
	else
		_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText(BLOCK_TRADES)
		_G['InterfaceOptionsControlsPanelBlockTrades']:Enable()
	end
end

function DeclinerPanel:CleanVars()
	d.v.opt=nil
	d.v.opt={
		duel={enabled,tell,guild,friend,bnet,message,},
		pet={enabled,tell,guild,friend,bnet,message,},
		guild={enabled,tell,friend,bnet,message,},
		group={enabled,tell,guild,friend,bnet,message,},
		chart={enabled,tell,guild,friend,bnet,message,},
		trade={enabled,tell,guild,friend,bnet,message,},
		dcl={messages,disable,},
	}
end

function DeclinerPanel:CreateText(xloc,yloc,justify,text)
	textnum=textnum+1
	textname=DCL..'TextGlobal'..format('%02i',textnum)
	settext=DeclinerPanel:CreateFontString(textname,'ARTWORK','GameFontNormalSmall')
	settext:SetPoint(justify,DeclinerPanel,'TOPLEFT',xloc,yloc)
	settext:SetText(text)
	return settext
end

function DeclinerPanel:CreateCheckBox(xloc,yloc,tooltip,text)
	checkboxnum=checkboxnum+1
	checkboxname=DCL..'CheckBoxGlobal'..format('%02i',checkboxnum)
	checkbox=CreateFrame('CheckButton',checkboxname,DeclinerPanel,'InterfaceOptionsCheckButtonTemplate')
	checkbox:SetPoint('CENTER',DeclinerPanel,'TOPLEFT',xloc,yloc)
	checkbox:SetHitRectInsets(0,0,0,0)
	checkbox.tooltipText=tooltip
	_G[checkboxname..'Text']:SetText('|cffffd100'..text)
	return checkbox
end

function DeclinerPanel:Options()
	DeclinerPanel.name=DCL
	InterfaceOptions_AddCategory(DeclinerPanel,DCL)
	DeclinerText01=DeclinerPanel:CreateText(144,-32,'CENTER',DUEL)
	DeclinerText02=DeclinerPanel:CreateText(144,-48,'CENTER',GUILDINFOTAB_APPLICANTS_NONE)
	DeclinerText03=DeclinerPanel:CreateText(208,-32,'CENTER',PET_BATTLE_PVP_DUEL)
	DeclinerText04=DeclinerPanel:CreateText(208,-48,'CENTER',GUILDINFOTAB_APPLICANTS_NONE)
	DeclinerText05=DeclinerPanel:CreateText(272,-32,'CENTER',GUILD)
	DeclinerText06=DeclinerPanel:CreateText(272,-48,'CENTER',Decliner:Pattern(GUILDEVENT_TYPE_INVITE))
	DeclinerText07=DeclinerPanel:CreateText(336,-32,'CENTER',GROUP)
	DeclinerText08=DeclinerPanel:CreateText(336,-48,'CENTER',Decliner:Pattern(GUILDEVENT_TYPE_INVITE))
	DeclinerText09=DeclinerPanel:CreateText(400,-32,'CENTER',ARENA..'/'..GUILD)
	DeclinerText10=DeclinerPanel:CreateText(400,-48,'CENTER',Decliner:Pattern(PETITION_TITLE))
	DeclinerText11=DeclinerPanel:CreateText(464,-32,'CENTER',TRADE)
	DeclinerText12=DeclinerPanel:CreateText(464,-48,'CENTER',GUILDINFOTAB_APPLICANTS_NONE)
	DeclinerText13=DeclinerPanel:CreateText(8,-80,'LEFT',ENABLE..' '..DECLINE)
	DeclinerCheckBox01=DeclinerPanel:CreateCheckBox(144,-80,'|cff00ff00'..d.L['DUEL_ENABLE'],'')
	DeclinerCheckBox02=DeclinerPanel:CreateCheckBox(208,-80,'|cff00ff00'..d.L['PET_ENABLE'],'')
	DeclinerCheckBox03=DeclinerPanel:CreateCheckBox(272,-80,'|cff00ff00'..d.L['GUILD_ENABLE'],'')
	DeclinerCheckBox04=DeclinerPanel:CreateCheckBox(336,-80,'|cff00ff00'..d.L['GROUP_ENABLE'],'')
	DeclinerCheckBox05=DeclinerPanel:CreateCheckBox(400,-80,'|cff00ff00'..d.L['CHART_ENABLE'],'')
	DeclinerCheckBox06=DeclinerPanel:CreateCheckBox(464,-80,'|cff00ff00'..d.L['TRADE_ENABLE'],'')
	DeclinerText14=DeclinerPanel:CreateText(8,-144,'LEFT',d.L['TELL_TITLE'])
	DeclinerCheckBox07=DeclinerPanel:CreateCheckBox(144,-144,'|cffff0000'..d.L['DUEL_TELL'],'')
	DeclinerCheckBox08=DeclinerPanel:CreateCheckBox(208,-144,'|cffff0000'..d.L['PET_TELL'],'')
	DeclinerCheckBox09=DeclinerPanel:CreateCheckBox(272,-144,'|cffff0000'..d.L['GUILD_TELL'],'')
	DeclinerCheckBox10=DeclinerPanel:CreateCheckBox(336,-144,'|cffff0000'..d.L['GROUP_TELL'],'')
	DeclinerCheckBox11=DeclinerPanel:CreateCheckBox(400,-144,'|cffff0000'..d.L['CHART_TELL'],'')
	DeclinerCheckBox12=DeclinerPanel:CreateCheckBox(464,-144,'|cffff0000'..d.L['TRADE_TELL'],'')
	DeclinerText15=DeclinerPanel:CreateText(8,-208,'LEFT',Decliner:Pattern(INSPECT_GUILD_NUM_MEMBERS))
	DeclinerCheckBox13=DeclinerPanel:CreateCheckBox(144,-208,'|cffff0000'..d.L['DUEL_GUILD'],'')
	DeclinerCheckBox14=DeclinerPanel:CreateCheckBox(208,-208,'|cffff0000'..d.L['PET_GUILD'],'')
	DeclinerCheckBox15=DeclinerPanel:CreateCheckBox(272,-208,'|cffff0000'..d.L['GUILD_GUILD'],'')
	DeclinerCheckBox16=DeclinerPanel:CreateCheckBox(336,-208,'|cffff0000'..d.L['GROUP_GUILD'],'')
	DeclinerCheckBox17=DeclinerPanel:CreateCheckBox(400,-208,'|cffff0000'..d.L['CHART_GUILD'],'')
	DeclinerCheckBox18=DeclinerPanel:CreateCheckBox(464,-208,'|cffff0000'..d.L['TRADE_GUILD'],'')
	DeclinerText16=DeclinerPanel:CreateText(8,-272,'LEFT',Decliner:Pattern(FRIENDS_LIST_REALM)..' '..FRIENDS)
	DeclinerCheckBox19=DeclinerPanel:CreateCheckBox(144,-272,'|cffff0000'..d.L['DUEL_FRIEND'],'')
	DeclinerCheckBox20=DeclinerPanel:CreateCheckBox(208,-272,'|cffff0000'..d.L['PET_FRIEND'],'')
	DeclinerCheckBox21=DeclinerPanel:CreateCheckBox(272,-272,'|cffff0000'..d.L['GUILD_FRIEND'],'')
	DeclinerCheckBox22=DeclinerPanel:CreateCheckBox(336,-272,'|cffff0000'..d.L['GROUP_FRIEND'],'')
	DeclinerCheckBox23=DeclinerPanel:CreateCheckBox(400,-272,'|cffff0000'..d.L['CHART_FRIEND'],'')
	DeclinerCheckBox24=DeclinerPanel:CreateCheckBox(464,-272,'|cffff0000'..d.L['TRADE_FRIEND'],'')
	DeclinerText17=DeclinerPanel:CreateText(8,-336,'LEFT',REAL_ID..'/'..BATTLETAG)
	DeclinerCheckBox25=DeclinerPanel:CreateCheckBox(144,-336,'|cffff0000'..d.L['DUEL_BNET'],'')
	DeclinerCheckBox26=DeclinerPanel:CreateCheckBox(208,-336,'|cffff0000'..d.L['PET_BNET'],'')
	DeclinerCheckBox27=DeclinerPanel:CreateCheckBox(272,-336,'|cffff0000'..d.L['GUILD_BNET'],'')
	DeclinerCheckBox28=DeclinerPanel:CreateCheckBox(336,-336,'|cffff0000'..d.L['GROUP_BNET'],'')
	DeclinerCheckBox29=DeclinerPanel:CreateCheckBox(400,-336,'|cffff0000'..d.L['CHART_BNET'],'')
	DeclinerCheckBox30=DeclinerPanel:CreateCheckBox(464,-336,'|cffff0000'..d.L['TRADE_BNET'],'')
	DeclinerText18=DeclinerPanel:CreateText(8,-400,'LEFT',SYSTEM_MESSAGES)
	DeclinerCheckBox31=DeclinerPanel:CreateCheckBox(144,-400,'|cffff0000'..HIDE..' \''..DCL..':'..DUEL..'\' '..SYSTEM_MESSAGES,'')
	DeclinerCheckBox32=DeclinerPanel:CreateCheckBox(208,-400,'|cffff0000'..HIDE..' \''..DCL..':'..PET_BATTLE_PVP_DUEL..'\' '..SYSTEM_MESSAGES,'')
	DeclinerCheckBox33=DeclinerPanel:CreateCheckBox(272,-400,'|cffff0000'..HIDE..' \''..DCL..':'..GUILD..'\' '..SYSTEM_MESSAGES,'')
	DeclinerCheckBox34=DeclinerPanel:CreateCheckBox(336,-400,'|cffff0000'..HIDE..' \''..DCL..':'..GROUP..'\' '..SYSTEM_MESSAGES,'')
	DeclinerCheckBox35=DeclinerPanel:CreateCheckBox(400,-400,'|cffff0000'..HIDE..' \''..DCL..':'..Decliner:Pattern(PETITION_TITLE)..'\' '..SYSTEM_MESSAGES,'')
	DeclinerCheckBox36=DeclinerPanel:CreateCheckBox(464,-400,'|cffff0000'..HIDE..' \''..DCL..':'..TRADE..'\' '..SYSTEM_MESSAGES,'')
	DeclinerCheckBox37=DeclinerPanel:CreateCheckBox(144,-464,'|cffff0000'..d.L['DISABLE_MESSAGES'],DISABLE..' '..strupper(ALL)..' '..DCL..' '..SYSTEM_MESSAGES)
	DeclinerCheckBox38=DeclinerPanel:CreateCheckBox(144,-496,'|cffff0000'..d.L['MAIN_DISABLE'],DISABLE..' '..DCL)
	DeclinerCheckBox01:SetScript('PostClick',function()d.v.opt.duel.enabled=DeclinerCheckBox01:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox02:SetScript('PostClick',function()d.v.opt.pet.enabled=DeclinerCheckBox02:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox03:SetScript('PostClick',function()d.v.opt.guild.enabled=DeclinerCheckBox03:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()Decliner:BlizzardGT()end)
	DeclinerCheckBox04:SetScript('PostClick',function()d.v.opt.group.enabled=DeclinerCheckBox04:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox05:SetScript('PostClick',function()d.v.opt.chart.enabled=DeclinerCheckBox05:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox06:SetScript('PostClick',function()d.v.opt.trade.enabled=DeclinerCheckBox06:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()Decliner:BlizzardGT()end)
	DeclinerCheckBox07:SetScript('PostClick',function()d.v.opt.duel.tell=DeclinerCheckBox07:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox08:SetScript('PostClick',function()d.v.opt.pet.tell=DeclinerCheckBox08:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox09:SetScript('PostClick',function()d.v.opt.guild.tell=DeclinerCheckBox09:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox10:SetScript('PostClick',function()d.v.opt.group.tell=DeclinerCheckBox10:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox11:SetScript('PostClick',function()d.v.opt.chart.tell=DeclinerCheckBox11:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox12:SetScript('PostClick',function()d.v.opt.trade.tell=DeclinerCheckBox12:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox13:SetScript('PostClick',function()d.v.opt.duel.guild=DeclinerCheckBox13:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox14:SetScript('PostClick',function()d.v.opt.pet.guild=DeclinerCheckBox14:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox15:SetScript('PostClick',function()if soundhandle then StopSound(soundhandle)end x=random(1,51000)_,soundhandle=PlaySoundKitID(x)DeclinerCheckBox15:SetChecked(false)end)
	DeclinerCheckBox16:SetScript('PostClick',function()d.v.opt.group.guild=DeclinerCheckBox16:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox17:SetScript('PostClick',function()d.v.opt.chart.guild=DeclinerCheckBox17:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox18:SetScript('PostClick',function()d.v.opt.trade.guild=DeclinerCheckBox18:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox19:SetScript('PostClick',function()d.v.opt.duel.friend=DeclinerCheckBox19:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox20:SetScript('PostClick',function()d.v.opt.pet.friend=DeclinerCheckBox20:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox21:SetScript('PostClick',function()d.v.opt.guild.friend=DeclinerCheckBox21:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox22:SetScript('PostClick',function()d.v.opt.group.friend=DeclinerCheckBox22:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox23:SetScript('PostClick',function()d.v.opt.chart.friend=DeclinerCheckBox23:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox24:SetScript('PostClick',function()d.v.opt.trade.friend=DeclinerCheckBox24:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox25:SetScript('PostClick',function()d.v.opt.duel.bnet=DeclinerCheckBox25:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox26:SetScript('PostClick',function()d.v.opt.pet.bnet=DeclinerCheckBox26:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox27:SetScript('PostClick',function()d.v.opt.guild.bnet=DeclinerCheckBox27:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox28:SetScript('PostClick',function()d.v.opt.group.bnet=DeclinerCheckBox28:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox29:SetScript('PostClick',function()d.v.opt.chart.bnet=DeclinerCheckBox29:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox30:SetScript('PostClick',function()d.v.opt.trade.bnet=DeclinerCheckBox30:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox31:SetScript('PostClick',function()d.v.opt.duel.message=DeclinerCheckBox31:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox32:SetScript('PostClick',function()d.v.opt.pet.message=DeclinerCheckBox32:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox33:SetScript('PostClick',function()d.v.opt.guild.message=DeclinerCheckBox33:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox34:SetScript('PostClick',function()d.v.opt.group.message=DeclinerCheckBox34:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox35:SetScript('PostClick',function()d.v.opt.chart.message=DeclinerCheckBox35:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox36:SetScript('PostClick',function()d.v.opt.trade.message=DeclinerCheckBox36:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox37:SetScript('PostClick',function()d.v.opt.dcl.messages=DeclinerCheckBox37:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()end)
	DeclinerCheckBox38:SetScript('PostClick',function()d.v.opt.dcl.disable=DeclinerCheckBox38:GetChecked()DeclinerPanel:MainEventReg()DeclinerUpdate:Print()Decliner:BlizzardGT()end)
	DeclinerUpdate:ClearAllPoints()
	DeclinerUpdate:SetHeight(8)
	DeclinerUpdate:SetWidth(8)
	DeclinerUpdate.text=DeclinerUpdate:CreateFontString('DeclinerOptionUpdateAlert','ARTWORK','GameFontNormal')
	DeclinerUpdate.text:SetPoint('RIGHT',DeclinerUpdate)
	DeclinerUpdate:SetPoint('BOTTOMRIGHT',InterfaceOptionsFrame,-64,64)
	DeclinerPanel.refresh=function()
		DeclinerPanel:SetCheckBoxes()
		DeclinerPanel:MainEventReg()
		d.v.temp=d.v.opt
	end
	DeclinerPanel.okay=function()
		Decliner_SV=d.v.opt
		Decliner_SV.saved=true
		d.v.temp=nil
	end
	DeclinerPanel.cancel=function()
		d.v.opt=d.v.temp
		DeclinerPanel:MainEventReg()
	end
	DeclinerPanel.default=function()
		DeclinerPanel:CleanVars()
		d.v.opt=d.v.default
		Decliner_SV=d.v.default
		Decliner_SV.saved=true
		DeclinerUpdate:Print()
	end
	SLASH_DECLINER_1='/decliner'
	SLASH_DECLINER_2='/decline'
	SLASH_DECLINER_3='/dcl'
	SlashCmdList['DECLINER_']=function()InterfaceOptionsFrame_OpenToCategory(DCL)end
end

function DeclinerPanel:SetCheckBoxes()
	DeclinerCheckBox01:SetChecked(d.v.opt.duel.enabled)
	DeclinerCheckBox02:SetChecked(d.v.opt.pet.enabled)
	DeclinerCheckBox03:SetChecked(d.v.opt.guild.enabled)
	DeclinerCheckBox04:SetChecked(d.v.opt.group.enabled)
	DeclinerCheckBox05:SetChecked(d.v.opt.chart.enabled)
	DeclinerCheckBox06:SetChecked(d.v.opt.trade.enabled)
	DeclinerCheckBox07:SetChecked(d.v.opt.duel.tell)
	DeclinerCheckBox08:SetChecked(d.v.opt.pet.tell)
	DeclinerCheckBox09:SetChecked(d.v.opt.guild.tell)
	DeclinerCheckBox10:SetChecked(d.v.opt.group.tell)
	DeclinerCheckBox11:SetChecked(d.v.opt.chart.tell)
	DeclinerCheckBox12:SetChecked(d.v.opt.trade.tell)
	DeclinerCheckBox13:SetChecked(d.v.opt.duel.guild)
	DeclinerCheckBox14:SetChecked(d.v.opt.pet.guild)
	DeclinerCheckBox15:SetChecked(false)
	DeclinerCheckBox16:SetChecked(d.v.opt.group.guild)
	DeclinerCheckBox17:SetChecked(d.v.opt.chart.guild)
	DeclinerCheckBox18:SetChecked(d.v.opt.trade.guild)
	DeclinerCheckBox19:SetChecked(d.v.opt.duel.friend)
	DeclinerCheckBox20:SetChecked(d.v.opt.pet.friend)
	DeclinerCheckBox21:SetChecked(d.v.opt.guild.friend)
	DeclinerCheckBox22:SetChecked(d.v.opt.group.friend)
	DeclinerCheckBox23:SetChecked(d.v.opt.chart.friend)
	DeclinerCheckBox24:SetChecked(d.v.opt.trade.friend)
	DeclinerCheckBox25:SetChecked(d.v.opt.duel.bnet)
	DeclinerCheckBox26:SetChecked(d.v.opt.pet.bnet)
	DeclinerCheckBox27:SetChecked(d.v.opt.guild.bnet)
	DeclinerCheckBox28:SetChecked(d.v.opt.group.bnet)
	DeclinerCheckBox29:SetChecked(d.v.opt.chart.bnet)
	DeclinerCheckBox30:SetChecked(d.v.opt.trade.bnet)
	DeclinerCheckBox31:SetChecked(d.v.opt.duel.message)
	DeclinerCheckBox32:SetChecked(d.v.opt.pet.message)
	DeclinerCheckBox33:SetChecked(d.v.opt.guild.message)
	DeclinerCheckBox34:SetChecked(d.v.opt.group.message)
	DeclinerCheckBox35:SetChecked(d.v.opt.chart.message)
	DeclinerCheckBox36:SetChecked(d.v.opt.trade.message)
	DeclinerCheckBox37:SetChecked(d.v.opt.dcl.messages)
	DeclinerCheckBox38:SetChecked(d.v.opt.dcl.disable)
end

local DeclinerUpdate_OnUpdate=function()
	if (update < GetTime()-1) then
		alpha=DeclinerUpdate:GetAlpha()
		if (alpha ~= 0) then DeclinerUpdate:SetAlpha(alpha-.05) end
		if (alpha == 0) then DeclinerUpdate:SetScript('OnUpdate',nil) end
	end
end

function DeclinerUpdate:Print()
	DeclinerUpdate.text:SetText('|cff00ff00Saved')
	DeclinerUpdate:SetAlpha(1)
	DeclinerUpdate:SetScript('OnUpdate',DeclinerUpdate_OnUpdate)
	update=GetTime()
end

--	Decliner: below code pasted from http://www.curse.com/addons/wow/blizzbugssuck (minus the superfluous 'do...end' wrap)
--	Decliner: still broken in 6.2.0.20253

--	Fix InterfaceOptionsFrame_OpenToCategory not actually opening the category (and not even scrolling to it)
--	Confirmed still broken in 6.0.3.19243

local function get_panel_name(panel)
	local tp=type(panel)
	local cat=INTERFACEOPTIONS_ADDONCATEGORIES
	if tp == 'string' then
		for i=1,#cat do
			local p=cat[i]
			if p.name == panel then
				if p.parent then
					return get_panel_name(p.parent)
				else
					return panel
				end
			end
		end
	elseif tp == 'table' then
		for i=1,#cat do
			local p=cat[i]
			if p == panel then
				if p.parent then
					return get_panel_name(p.parent)
				else
					return panel.name
				end
			end
		end
	end
end
local function InterfaceOptionsFrame_OpenToCategory_Fix(panel)
	if doNotRun or InCombatLockdown() then return end
	local panelName=get_panel_name(panel)
	if not panelName then return end -- if its not part of our list return early
	local noncollapsedHeaders={}
	local shownpanels=0
	local mypanel
	local t={}
	local cat=INTERFACEOPTIONS_ADDONCATEGORIES
	for i=1,#cat do
		local panel=cat[i]
		if not panel.parent or noncollapsedHeaders[panel.parent] then
			if panel.name == panelName then
				panel.collapsed=true
				t.element=panel
				InterfaceOptionsListButton_ToggleSubCategories(t)
				noncollapsedHeaders[panel.name]=true
				mypanel=shownpanels + 1
			end
			if not panel.collapsed then
				noncollapsedHeaders[panel.name]=true
			end
			shownpanels=shownpanels + 1
		end
	end
	local Smin,Smax=InterfaceOptionsFrameAddOnsListScrollBar:GetMinMaxValues()
	if shownpanels > 15 and Smin < Smax then
		local val=(Smax/(shownpanels-15))*(mypanel-2)
		InterfaceOptionsFrameAddOnsListScrollBar:SetValue(val)
	end
	doNotRun=true
	InterfaceOptionsFrame_OpenToCategory(panel)
	doNotRun=false
end
hooksecurefunc('InterfaceOptionsFrame_OpenToCategory',InterfaceOptionsFrame_OpenToCategory_Fix)